dofile("screen_reader_common.inc");
dofile("ui_utils.inc");

loadfile("screen_reader_common.inc")();
loadfile("ui_utils.inc")();

per_click_delay = 200;
waitDelay = 100;

up = nil;
right_click = nil;

button_names = {
"Linen",
"Canvas",
"Wool",
"Un-Pin Windows"
};

function waitForChange()
	local c=0;
	while srReadPixel(setWaitSpot_x, setWaitSpot_y) == setWaitSpot_px do
		lsSleep(1);
		c = c+1;
		if (lsShiftHeld() and lsControlHeld()) then
			error 'broke out of loop from Shift+Ctrl';
		end
	end
	-- lsPrintln('Waited ' .. c .. 'ms for pixel to change.');
end

function clickAll(image_name, up)
	-- Find buttons and click them!
	srReadScreen();
	local buttons = findAllImages(image_name);
	
	if #buttons == 0 then
		return nil;
	else
		if up then
			for i=#buttons, 1, -1  do
				srClickMouseNoMove(buttons[i][0]+5, buttons[i][1]+3);
				lsSleep(per_click_delay);
			end
		else
			for i=1, #buttons  do
				srClickMouseNoMove(buttons[i][0]+5, buttons[i][1]+3);
				lsSleep(per_click_delay);
			end
		end
		lsSleep(50);
		return 1;
	end
end



function clickAllRight(image_name)
	-- Find windows and click them!
	srReadScreen();
	xyWindowSize = srGetWindowSize();
	local buttons = findAllImages(image_name);
	
	if #buttons == 0 then
		statusScreen("Could not find any pinned up windows...");
		lsSleep(1500);
	else
		statusScreen("Clicking " .. #buttons .. "windows(s)...");
		if up then
			for i=#buttons, 1, -1  do
				srClickMouseNoMove(buttons[i][0]+5, buttons[i][1]+3, true);
				lsSleep(per_click_delay);
			end
		else
			for i=1, #buttons  do
				srClickMouseNoMove(buttons[i][0]+5, buttons[i][1]+3, true);
				lsSleep(per_click_delay);
			end
		end
		statusScreen("Done clicking (" .. #buttons .. " windows).");
		lsSleep(100);
	end
end

function refocus()
	statusScreen("Refocusing...");
	for i=2, #window_locs do
		setWaitSpot(window_locs[i][0], window_locs[i][1]);
		srClickMouseNoMove(window_locs[i][0] + 321, window_locs[i][1] + 74);
		waitForChange();
	end
end


function Unpin()

	askForWindow("Press Shift key to unpin/close all pinned windows. If you should get any errors, put ATITD window in focus first, before pressing Shift key.");
	
	srReadScreen();

	window_locs = findAllImages("This.png");

	clickAllRight("This.png", 1);
	lsSleep(200);
	
end


function Linen()
	local num_rounds;
	askForWindow("Ensure your hand loom is pinned and your skills tab selected before starting. Hold the thread in your inventory, click in ATITD and press shift");
	local count = 0;
	while true do
		statusScreen("Linen Woven: " .. count);
		--load linen
		srReadScreen();
		buttons = findOneImage("LoadThread.png");
		
		if #buttons > 0 then
			srClickMouseNoMove(buttons[1][0]+2, buttons[1][1] + 2, right_click);
			lsSleep(per_click_delay);
		end
		
		while clickAll("Max.png") ~= nil do
		end
		
		while clickAll("Ok.png") ~= nil do
		end
		
		--wait until enduranec is black
		
		srReadScreen();
		buttons = findOneImage("Endurance-Black.png");
		while #buttons == 0 do
			statusScreen("Linen Woven: " .. count);
			lsSleep(waitDelay);
			srReadScreen();
			buttons = findOneImage("Endurance-Black.png");
		end
		srReadScreen();
		buttons = findOneImage("WeaveLinen.png");
		if #buttons > 0 then
			srClickMouseNoMove(buttons[1][0]+2, buttons[1][1] + 2, right_click);
			lsSleep(per_click_delay);
		count = count + 1;
		end
	end
end

function Canvas()
	local num_rounds;
	askForWindow("Ensure your hand loom is pinned and your skills tab selected before starting. Hold the twine in your inventory, click in ATITD and press shift");
	local count = 0;
	while true do
		statusScreen("Canvas Woven: " .. count);
		--load linen
		srReadScreen();
		buttons = findOneImage("LoadTwine.png");
		
		if #buttons > 0 then
			srClickMouseNoMove(buttons[1][0]+2, buttons[1][1] + 2, right_click);
			lsSleep(per_click_delay);
		end
		
		while clickAll("Max.png") ~= nil do
		end
		
		while clickAll("Ok.png") ~= nil do
		end
		
		--wait until enduranec is black
		
		srReadScreen();
		buttons = findOneImage("Endurance-Black.png");
		while #buttons == 0 do
			statusScreen("Canvas Woven: " .. count);
			lsSleep(waitDelay);
			srReadScreen();
			buttons = findOneImage("Endurance-Black.png");
		end
		srReadScreen();
		buttons = findOneImage("WeaveTwine.png");
		if #buttons > 0 then
			srClickMouseNoMove(buttons[1][0]+2, buttons[1][1] + 2, right_click);
			lsSleep(per_click_delay);
		count = count + 1;
		end
	end
end

function Wool()
	local num_rounds;
	askForWindow("Ensure your hand loom is pinned and your skills tab selected before starting. Hold the yarn in your inventory, click in ATITD and press shift");
	local count = 0;
	while true do
		statusScreen("Wool Cloth Woven: " .. count);
		--load linen
		srReadScreen();
		buttons = findOneImage("LoadYarn.png");
		
		if #buttons > 0 then
			srClickMouseNoMove(buttons[1][0]+2, buttons[1][1] + 2, right_click);
			lsSleep(per_click_delay);
		end
		
		while clickAll("Max.png") ~= nil do
		end
		
		while clickAll("Ok.png") ~= nil do
		end
		
		--wait until enduranec is black
		
		srReadScreen();
		buttons = findOneImage("Endurance-Black.png");
		while #buttons == 0 do
			statusScreen("Wool Cloth Woven: " .. count);
			lsSleep(waitDelay);
			srReadScreen();
			buttons = findOneImage("Endurance-Black.png");
		end
		srReadScreen();
		buttons = findOneImage("WeaveYarn.png");
		if #buttons > 0 then
			srClickMouseNoMove(buttons[1][0]+2, buttons[1][1] + 2, right_click);
			lsSleep(per_click_delay);
		count = count + 1;
		end
	end
end

function doit()
	while 1 do
		-- Ask for which button
		local image_name = nil;
		local is_done = nil;	
		while not is_done do
			local y = nil;
			local x = nil;
			local bsize = nil;
			for i=1, #button_names do
				if button_names[i] == "Linen" then
					x = 30;
					y = 10;
					bsize = 130;
				elseif button_names[i] == "Canvas" then
					x = 30;
					y = 40;
					bsize = 130;
				elseif button_names[i] == "Wool" then
					x = 30;
					y = 70;
				elseif button_names[i] == "Un-Pin Windows" then
					x = 30;
					y = 130;
					bsize = 200;
					end



				if lsButtonText(x, y, 0, 250, 0xe5d3a2ff, button_names[i]) then
					image_name = button_names[i];
					is_done = 1;
				end
			end

			if lsButtonText(lsScreenX - 220, lsScreenY - 30, z, 150, 0xFF0000ff, "End script") then
				error "Clicked End Script button";
			end
			lsDoFrame();
			lsSleep(10);
		end	
		
		if image_name == "Linen" then
			Linen();
		elseif image_name == "Canvas" then
			Canvas();
		elseif image_name == "Wool" then
			Wool();
		elseif image_name == "Un-Pin Windows" then
			Unpin();

		end
	end
end